 /**
 * Execeliga vahetatakse mlupuhvri kaudu andmeid tekstikujul, 
 * kus lahtreid eraldavad tabulaatorid ning ridu reavahetused. 
 * Siinse klassi isendi saab JTable mber kinnitada, nii et tabel 
 * hakkab reageerima klahvikombinatsioonidele CTRL+C ja CTRL+V. 
 */

 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.awt.datatransfer.*;
 import java.util.*;

 public class ExceliAdapter implements ActionListener {
   private String rowstring,value;
   private Clipboard puhver;
   private StringSelection stsel;
   private JTable tabel ;


   public ExceliAdapter(JTable uustabel) {  
  	  tabel = uustabel;
	  KeyStroke copy = KeyStroke.getKeyStroke(KeyEvent.VK_C,ActionEvent.CTRL_MASK,false);
	   //klahv C, CTRL all ning klahvi leststmisel ei reageeri. 
	  KeyStroke paste = KeyStroke.getKeyStroke(KeyEvent.VK_V,ActionEvent.CTRL_MASK,false);
	  tabel.registerKeyboardAction(this,"Copy",copy,JComponent.WHEN_FOCUSED);
	  tabel.registerKeyboardAction(this,"Paste",paste,JComponent.WHEN_FOCUSED);
	  puhver = Toolkit.getDefaultToolkit().getSystemClipboard();
   }


	public void actionPerformed(ActionEvent e) {
	  if (e.getActionCommand().equals("Copy")){
	    StringBuffer sbf=new StringBuffer();		
		  int veerge=tabel.getSelectedColumnCount();
		  int ridu=tabel.getSelectedRowCount();
		  int[] read=tabel.getSelectedRows();
		  int[] veerud=tabel.getSelectedColumns();
		
		  for (int i=0;i<ridu;i++){
		     for (int j=0;j<veerge;j++){
		       sbf.append(tabel.getValueAt(read[i],veerud[j]));
		       if (j<veerge-1) sbf.append("\t");
		     }
		     sbf.append("\n");
		  }
		  stsel = new StringSelection(sbf.toString());
		  puhver.setContents(stsel,stsel);
	  }
	
	
	 if (e.getActionCommand().compareTo("Paste")==0) {
	  int algrida=(tabel.getSelectedRows())[0];
	  int algveerg=(tabel.getSelectedColumns())[0];
	  try {
		  String puhvrisone=(String)
		     (puhver.getContents(this).getTransferData(DataFlavor.stringFlavor));
		  StringTokenizer st1=new StringTokenizer(puhvrisone,"\n");
		  for(int i=0;st1.hasMoreTokens();i++)  {
		    String reasone=st1.nextToken();
		    StringTokenizer st2=new StringTokenizer(reasone,"\t");
		    for(int j=0;st2.hasMoreTokens();j++){
		      String vaartus=(String)st2.nextToken();
		      if (algrida+i< tabel.getRowCount() && algveerg+j< tabel.getColumnCount())
		         tabel.setValueAt(vaartus,algrida+i,algveerg+j);
		    }
		  }
	  }  catch(Exception ex){ex.printStackTrace();}
	 }
	}
	
 //------------------------ kasutamise nide
 
 static JTable korrutustabel(){
   Object[][] andmed=new Object[10][10];
	for (int i=1;i<=10;i++)
	for (int j=1;j<=10;j++)
	 andmed[i-1][j-1]=i*j+""; 
	JTable tabel=new JTable(andmed, andmed[0]); 
	  //andmed ja pealkiri, milleks on hega korrutamise rida. 
	
	return tabel;
 }


 public static void main(String args[]) {
  JFrame f=new JFrame("Swingitabel");
  f.setSize(250,250);
  JTable tabel1=korrutustabel();
  tabel1.setCellSelectionEnabled(true);
  new ExceliAdapter(tabel1); //Adapter tabelile selga
  f.getContentPane().add(new JScrollPane(tabel1));
  f.setVisible(true);
 }

}
